#ifndef COMMON_CUH
#define COMMON_CUH
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <string>
#include <vector>
#include <algorithm>
#include "cuda_runtime.h"
#include "device_launch_parameters.h"

//0~(ATOM_NUMBES_IN_NEIGHBOR_GRID_BUCKET_MAX-1)ҵ0¼ǸøĿǰ¼ԭĿ+1ʵֻATOM_NUMBES_IN_NEIGHBOR_GRID_BUCKET_MAX-1
//Ϊfor(int i=1;i<atom_serial[0];i=i+1)ʵʺԭΪatom_serial[0]-1
#define ATOM_NUMBES_IN_NEIGHBOR_GRID_BUCKET_MAX 64
struct NEIGHBOR_GRID_BUCKET
{
	int atom_serial[ATOM_NUMBES_IN_NEIGHBOR_GRID_BUCKET_MAX];
};
struct INT_FLOAT
{
	int id;
	float energy;
};
bool cmp(INT_FLOAT& a, INT_FLOAT& b);

struct UINT2
{
	unsigned int a;
	unsigned int b;
};
struct VECTOR {
	float x;
	float y;
	float z;
};
struct VECTOR_INT {
	float x;
	float y;
	float z;
	int type;
};
struct INT_VECTOR {
	int int_x;
	int int_y;
	int int_z;
};

//תĽڵϢṹ
struct NODE
{
	float matrix[9];//¼nתthetaǶȵľ
	int root_atom_serial;//ʸaʱ̴Ӹatom crdл
	int branch_atom_serial;//ʸnʱ̴Ӹatom crdaмõ
	VECTOR a0, n0, a, n;//ʼλa0ָn0ǰan
	int last_node_serial;//һڵţڵ㣩
};


//Vina 
#define k_gauss1  -0.035579f
#define k_gauss1_2  4.f

#define k_gauss2  -0.005156f
#define k_gauss2_2  0.25f
#define k_gauss2_c  3.f

#define k_repulsion  +0.840245f

#define k_hydrophobic  -0.035069f
#define k_hydrophobic_a  0.5f
#define k_hydrophobic_b  1.5f
#define k_hydrophobic_ua  1.f
#define k_hydrophobic_ub  0.f

#define k_h_bond  -0.587439f
#define k_h_bond_a  -0.7f
#define k_h_bond_b  0.f
#define k_h_bond_ua  1.f
#define k_h_bond_ub  0.f
struct VINA_ATOM
{
	VECTOR crd;//ÿ£ligand
	//float charge;//ʱδʹ
	int atom_type;//ָʾ18vina atom type
	float radius;
	int is_hydrophobic;//=1 ˮģ=0
	int is_donor;//=1Ǹ壬=0
	int is_acceptor;//=1壬=0
};

FILE* fopen_safely(const char* file_name, const char* mode);
float real_distance(VECTOR& crd, VECTOR& crd2);
VECTOR unifom_rand_Euler_angles();

//ҪPDBQTʽһԭƷԭ
int Get_Atomic_Number_From_PDBQT_Atom_Name(const char *atom_name);

void Read_Atom_Line_In_PDBQT(const char* line, std::vector<VECTOR>& crd, std::vector<float>& charge, std::vector<int>& atom_type);
void Read_Atom_Line_In_MOL2(const char* line, std::vector<VECTOR>& crd, std::vector<float>& charge);

//vinaĽڱҪ޳ЩݣԼ1-2bond1-21-31-4Ԫءͬһڲ
//ע⣬ͬһڲͬʱҲʵתЧ-O-H,-N(-H)-HȽṹ
//neighbor_listǼ¼޳ʣҪķ໥pair󣬵atom_numbers*atom_numbers洢ʵ֣
//atom_node_serial޳ͬһڲ໥
void Build_Inner_Neighbor_List
(const int atom_numbers, int* neighbor_list, std::vector<VECTOR>& initial_crd, std::vector<int>& atomic_number,
	std::vector<int>& atom_node_serial);

//pdbqtеatom_typeͳʼ꣬մvina߼vina_atomڼ
int Build_Vina_Atom(VINA_ATOM* vina_atom, std::vector<int>& atom_type, std::vector<VECTOR>& initial_crd, std::vector<int>& atomic_number);

//ԭӵvina֣{ľֵ,}
float2 Vina_Pair_Interaction(VINA_ATOM a, VINA_ATOM b);
#endif//COMMON_CUH