import Xponge

import Xponge.forcefield.amber.gaff as gaff

assign1 = Xponge.Get_Assignment_From_Mol2("1ae5_HUP_ligand.mol2")

assign1.Determine_Atom_Type("gaff")

assign1.Calculate_Charge("resp")

HUP = assign1.toResidueType("HUP")

gaff.parmchk2_gaff(HUP, "HUP.frcmod")

Xponge.save_mol2(HUP, "HUP.mol2")

#保存HUP分子力场用于后续调用



import Xponge.forcefield.amber.ff14sb

C = Xponge.load_pdb("1ae5_protein.pdb", ignore_hydrogen=False, ignore_unknown_name=True, ignore_seqres=True)

C.add_missing_atoms()

HUP = Xponge.load_mol2("HUP.mol2")

gaff.parmchk2_gaff(HUP, "HUP.frcmod")

a = C | HUP



#如果是真空体系的话，可以采用下面命令行保存，同样需要在外部创建空文件夹1ae5V

#Xponge.save_pdb(a, "1ae5_pro_lig.pdb")

#Xponge.save_sponge_input(a, "1ae5V/1ae5")



#正常模拟生理状态加水的话，用下面的命令行

import Xponge.forcefield.amber.tip3p

Xponge.addSolventBox(a, WAT, 5)

#此处加溶剂水为tip3p水，参数5代表蛋白距离盒子边界5A，通常模拟会选更大的距离，以避免边界效应

print(C.charge+int(round(HUP.charge)))

#此处显示体系带3个单位负电荷，需要加入离子补到电中性#思考题，若要达到生理盐水的离子浓度，此处电荷数量是怎样算出来的？

Xponge.Solvent_Replace(a, WAT, {CL:8})

Xponge.save_pdb(a, "1ae5_pro_lig_sol.pdb")

Xponge.save_sponge_input(a, "1ae5/1ae5")
